<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.logging.view.LogViewerClient" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.logging.view.types.carbon.LogMessage" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<script type="text/javascript" src="js/logviewer.js"></script>
<script type="text/javascript" src="../admin/dialog/js/dialog.js"></script>


<%
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    LogViewerClient logViewerClient;
    String type;
    String keyword;
    String action;
    LogMessage[] logMessages;
    try {
        logViewerClient = new LogViewerClient(cookie, backendServerURL, configContext);

        type = request.getParameter("type");
        keyword = request.getParameter("keyword");
        action = request.getParameter("action");
        if (action != null && action.equals("clear-logs")) {
            logViewerClient.cleaLogs();
        }
        logMessages = logViewerClient.getLogs(type, keyword);

    } catch (Exception e) {
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
        <script type="text/javascript">
               location.href = "../admin/error.jsp";
        </script>
<%
        return;
    }
%>

<fmt:bundle basename="org.wso2.carbon.logview.ui.i18n.Resources">
<carbon:breadcrumb label="system.logs"
		resourceBundle="org.wso2.carbon.logview.ui.i18n.Resources"
		topPage="true" request="<%=request%>" />
    <div id="middle">
        <h2><fmt:message key="system.logs"/></h2>

        <div id="workArea">
           
                    <table border="0" class="styledLeft">
                        <tbody>
                        <tr>
                            <td class="formRow">
                            <table class="normal">
                            <tr>
                            <td><fmt:message key="view"/></td>
                            <td><select class="log-select" id="logLevelID"
                                        onchange="javascript:viewSingleLogLevel(); return false;">
                                <%
                                    String[] logLevels = logViewerClient.getLogLevels();
                                    if(keyword != null){
                                        type = "Custom";
                                %>

                                <option value="<%=type%>" selected="true"><%=type%></option>

                                <%
                                    }
                                    for (String logLevel : logLevels) {
                                        if (logLevel.equals(type)) {
                                %>

                                <option value="<%=logLevel%>" selected="true"><%=logLevel%></option>

                                <%
                                } else {
                                %>

                                <option value="<%=logLevel%>"><%=logLevel%></option>

                                <% }
                                }
                                %>
                            </select></td>
                            <td style="width: 100%;"></td>
                            <td>
                                <nobr><fmt:message key="search.logs"/></nobr>
                            </td>
                            <td><input onkeypress="submitenter(event)" value="" class="log-select"
                                       size="40"
                                       id="logkeyword" type="text"></td>
                            <td><a alt="Search Log " title="Search Log" onclick="javascript:searchLog(); return false;"
                                   style="background-image:url(images/magnifier.gif);"
                                   href="#" class="icon-link">
                                &nbsp;&nbsp;&nbsp;&nbsp;
                            </a></td>
                        </tr>
                        </table>
                        </td>
                        </tr>
                        </tbody>
                    </table>


                   <br/>
                    <table border="1" class="styledLeft">
                        <tbody>
                         <tr>
                            <td class="formRow">
                            <table class="styledLeft">


                        <%
                                int index = -1;
                                for (LogMessage logMessage : logMessages) {
                                    ++index;
                                    if (index % 2 != 0) {

                        %>
                        <tr>
                                    <%

                        } else {

                %>
                        <tr bgcolor="#eeeffb">
                            <%
                                }

                                String logLevel = logMessage.getType();
                                if (logLevel == null || logLevel.equals("")) {
                            %>
                            <td border-bottom="gray"></td>
                            <%
                            } else {
                            %>
                            <td border-bottom="gray"><img style="margin-right: 10px;"
                                                          src="<%=logViewerClient.getImageName(logMessage.getType())%>">
                            </td>
                            <%
                                }
                            %>
                            <td><%=logMessage.getLogMessage()%>
                            </td>
                        </tr>

                        <%
                            }
//                        } catch (Exception e) {
                        %>
                        <%--<tr>--%>
                            <%--<td border-bottom="gray"><img style="margin-right: 10px;"--%>
                                                          <%--src="cancel.gif"></td>--%>
                            <%--<td>Error - Failed to connect to the server</td>--%>
                        <%--</tr>--%>
                        <%--<%--%>
                                <%--e.printStackTrace();--%>
                            <%--}--%>
                        <%--%>--%>
                         </table>
                        </td>
                        </tr>

                    <tr>
                     <td class="buttonRow">
                            <input onclick="javascript:clearLogEntries();return false;"
                           value="<fmt:message key="clear.all"/>" class="button"
                           name="clearLogs" type="button">
                     </td>
                    </tr>

                        </tbody>
                    </table>
                </div>
    </div>
</fmt:bundle>
